## grep-dctrl 2.1.4

=== Makefile ===

sysconfdir = /etc
localedir = /usr/share/locale

CC = gcc -std=gnu99 
CFLAGS = -O2 -g -Wall -DENABLE_L_DEBUG -D_GNU_SOURCE -DSYSCONF=\"$(sysconfdir)\" \
         -DHAVE_GETTEXT -DPACKAGE=\"grep-dctrl\" -DLOCALEDIR=\"$(localedir)\"

CFLAGS += -DVERSION=\"$(shell dpkg-parsechangelog | grep '^Version' | cut -b10-)\"
CFLAGS += -DMAINTAINER='"$(shell grep ^Maintainer: debian/control | cut -b13-)"'

#CFLAGS += -pg
#LDFLAGS += -pg

#LDLIBS = -lpub

obj = grep-dctrl.o msg.o predicate.o util.o fsaf.o paragraph.o \
      fieldtrie.o rc.o strutil.o getaline.o fnutil.o
src = $(obj:.o=.c)

# List of translated languages is given in langs.mk
include langs.mk

all : grep-dctrl grep-dctrl.1 mo

pot : po/grep-dctrl.pot

po : $(foreach f,$(langs),po/$(f).po)

mo : $(foreach f,$(langs),po/$(f).mo)

grep-dctrl : $(obj)

%.test : %.test.o

%.test.o : %.c
	$(CC) -c $(CFLAGS) -DTESTMAIN $< -o $@

%.1 : %.1.cp
	sed 's*SYSCONF*$(sysconf)*' $< > $@

xgettext_opts=--copyright-holder="Antti-Juhani Kaijanaho" \
	      --msgid-bugs-address="ajk@debian.org" -kN_ -k_

po/%.po : po/grep-dctrl.pot
	msgmerge -q -U --backup=existing $@ $^

po/%.mo : po/%.po
	msgfmt -c --statistics -o $@ $< 

po/grep-dctrl.pot : $(src)
	xgettext $(xgettext_opts) -d grep-dctrl $^
	mv grep-dctrl.po $@

fsaf.test : fsaf.test.o msg.o

clean :
	$(RM) core grep-dctrl grep-dctrl.1 *.o po/*.mo po/*.pot TAGS

tags :
	etags *.[hc]

## grep-dctrl 1.3a

=== debian/changelog ===
grep-dctrl (1.3a) frozen; urgency=low

  * matcher.c (find_field): Unroll the first iteration of the first loop
    and then remove the special-case p==s if in the loop body. 
    Closes: bug#59455.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sun,  5 Mar 2000 14:21:41 +0200

grep-dctrl (1.3) frozen; urgency=low

  * grep-dctrl.c (main): Add a colon after c in getopt's
    argument, fixing the segfault in bug#57144.  This fix is meant
    for frozen and is minimal; I will upload a more complicated fix
    (but more correct in the long run) separately to unstable, since
    the better fix requires feature changes.
  * grep-dctrl.c (print_usage, main), grep-dctrl.1.cp, po/fi.po:
    Deprecated short option "-c" to allow its meaning to be changed later
    in woody.  Functionality is not changed in this version; only
    messages about the deprecation have been added. This must go to
    potato to allow a smooth transition to the better fix for bug#57144.
  * debian/copyright: Updated copyright years (added 2000).
  * debian/NEWS: documented this release's changes

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sun,  6 Feb 2000 14:50:06 +0200

grep-dctrl (1.2) unstable; urgency=low

  * grep-dctrl.c (main), matcher.h (struct matcher_t), matcher.c
    (grep_control): Implement the -v option suggested by David Coe.
    Closes: #45115.
  * debian/rules: Modernize.
      + Factor install into a variable.
      + Don't use install_gzip.
      + Use stamp files.
      + Split clean into {build,binary}-clean
      + Use a separate target for the configure call.
      + Don't test for rootness.
      + Remove $(rootdir) at start of binary targets.
  * grep-dctrl.1.cp: Documented the -v option.
  * debian/{prerm,postinst,rules}: Implement the /usr/doc transition method.
  * po/fi.po: Updated.
  * Compatibility: New file.
  * debian/rules: Install Compatibility.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Wed, 15 Sep 1999 20:06:20 +0300

grep-dctrl (1.1) unstable; urgency=low

  * matcher.c (grep_control): Only return on feof if the para is empty.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Mon,  2 Aug 1999 21:42:53 +0300

grep-dctrl (1.0) unstable; urgency=low

  * New major version.  No major changes, just polishing - we have
    been converging to 1.0 for some time now.
  * grep-dctrl.c (main): Don't allow -s to be used many times,
    as it does not work in the obvious way.
  * Updated the Finnish translation.
  * grep-dctrl.1.cp: Updated the DIAGNOSTICS section.
  * Added files TODO, NEWS and README to the source distribution.
    Only README is not relevant to Debian users, so not installing it.
  * configure.in: Check whether we have dpkg-parsechangelog, and
    use a default dummy version number if we don't.  This allows
    the package to build more easily on a non-Debian system.
  * Unsymlink things that had symlinks outside the source.
  * Added getopt source for the benefit of broken systems.
  * configure.in: Use /usr/share/common-licenses/GPL as a default for
    the copying file location.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sat, 10 Jul 1999 20:58:46 +0300

grep-dctrl (0.16) unstable; urgency=low

  * Upgraded Standards-Version to 3.0.0.0, with necessary
    changes to debian/rules and debian/copyright.
  * configure.in: Added an anchor to the grep in the version number,
    finder, and reran autoconf

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Fri,  2 Jul 1999 10:42:24 +0300

grep-dctrl (0.15) unstable; urgency=low

  * Removed the file called "1" from the source package.
    Closes: bug#40358.
  * debian/dpkg-sourcedeps: New file.
  * debian/rules: Converted the source dependency check to use
    debian/dpkg-sourcedeps
  * grep-dctrl.1.cp: Wrote an EXAMPLES section.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Mon, 28 Jun 1999 18:02:36 +0300

grep-dctrl (0.14) unstable; urgency=low

  * matcher.c (grep_control): Test for EOF before a paragraph
    is processed, not after.  This fixes an unreported bug
    that caused grep-dctrl -sPackage '' output a spurious
    empty Package: line.
  * debian/rules: Added a simple source dependency check.
  * debian/rules: Use -isp with dpkg-gencontrol.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sat, 26 Jun 1999 03:21:20 +0300

grep-dctrl (0.13) unstable; urgency=low

  * buffer.c (buffer_trim): I had ">=" in the loop
    condition, should be "<".  Corrected that; this
    fixes bug #38047.
  * Added debug_messages and asserts all over buffer.c
    while hunting bug #38047.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Thu, 20 May 1999 21:47:31 +0300

grep-dctrl (0.12) unstable; urgency=low

  * Removed old-Makefile.in from the tarball.
  * Updated Finnish translation.
  * Made field name matching ignore case.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Tue, 18 May 1999 08:53:42 +0300

grep-dctrl (0.11) unstable; urgency=low

  * Added shorthand option -P.
  * Fixed a typo in config file name in the manual page.
  * grep_dctrl (set_match_field): New function.
  * Fixed some -Wall warnings in matcher.c.
  * rc.c, line 107: Had forgotten the `++' in front of lineno.
    Corrected that.
  * Added the option -n for suppressing the field names on output.
  * Added a some informational messages to rcfile parsing.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Fri,  9 Apr 1999 20:24:30 +0300

grep-dctrl (0.10) unstable; urgency=low

  * Got rid of version.h.  The defines are now done on the
    compiler command line.  This will avoid the harmful rebuild of
    grep-dctrl.o in Makefile's install target. Fixes bug#35527.
  * Added the generated manual page to CLEANFILES, so that the
    manpage gets rebuilt.
  * Clean off backup files on debian/rules clean.
  * rc.c: Search user's rcfile first.
  * rc.c: Upgrade the "reading config file" message from debug message 
    to informational.
  * Updated the Finnish translation.
  * Prettified the long description in debian/control.


=== debian/control ===
Source: grep-dctrl
Section: utils
Priority: optional
Maintainer: Antti-Juhani Kaijanaho <ajk@debian.org>
Standards-Version: 3.0.0.0

Package: grep-dctrl
Architecture: any
Section: utils
Priority: optional
Depends: ${shlibs:Depends}
Description: Grep Debian package information
 The grep-dctrl program can answer such questions as
   "What is the Debian package foo?"
   "Which version of the Debian package bar is
     now current?"
   "Which Debian packages does John Doe maintain?"
   "Which Debian packages are somehow related to
     the Scheme programming language?"
 and with some help
   "Who maintain the essential packages of a
     Debian system?"
 given a useful input file.
 .
 It is a specialised grep program that
 is meant for processing any file which has the
 general format of a Debian package control file.
 These include the dpkg available file, the dpkg
 status file, and the Packages files on a distribution
 medium (such as a Debian CD-ROM or an FTP site
 carrying Debian).

=== debian/rules ===
#! /usr/bin/make -f 
# -*- Makefile -*-

# Written by Antti-Juhani Kaijanaho <ajk@debian.org>.  Use, distribute
# and modify as you please.

install         := install -o root -g root
install_exec    := $(install) -m 755 -s
install_dir     := $(install) -m 755 -d
install_nonex   := $(install) -m 644
install_script  := $(install) -m 755
install_zipped  := false
install_symlink := ln -s

GZIP = gzip -9

package    = grep-dctrl
rootdir    = `pwd`/debian/tmp
docdir     = $(rootdir)/usr/share/doc/$(package)
bindir     = $(rootdir)/usr/bin
mandir     = $(rootdir)/usr/share/man
man1dir    = $(mandir)/man1

build: debian/build.stamp
debian/build.stamp: debian/build-depends.stamp \
	            debian/build-configure.stamp
	$(checkdir)
	$(MAKE)
	touch $@

debian/build-configure.stamp:
	./configure --prefix=/usr --sysconfdir=/etc --mandir=/usr/share
	touch $@

debian/build-depends.stamp:
	$(checkdir)
	chmod u+x debian/check-sourcedeps
	debian/check-sourcedeps publib-dev
	touch $@

clean-build:
	$(RM) debian/build*.stamp
	-$(MAKE) distclean

binary: binary-arch binary-indep

binary-indep: debian/binary-indep.stamp
debian/binary-indep.stamp :
	touch $@

binary-arch: debian/binary-arch.stamp
debian/binary-arch.stamp : build
	$(checkdir)
	$(RM) -r $(rootdir)
#	Create the filesystem
	$(install_dir) $(rootdir)
	$(install_dir) $(rootdir)/DEBIAN
	$(install_dir) $(docdir)
#	Install by the master makefile
	$(MAKE) prefix=$(rootdir)/usr sysconfdir=$(rootdir)/etc \
	  mandir=$(mandir) install
#	Install copyright file.
	$(install_nonex) debian/copyright $(docdir)
#	Install the change logs.
	$(install_nonex) debian/changelog $(docdir)
	$(GZIP) $(docdir)/changelog
#	Install the binary.
	$(install_exec) grep-dctrl $(bindir)
	set -e ; for dest in grep-status grep-available ; do \
	   $(install_symlink) grep-dctrl $(bindir)/$$dest ; \
	 done
#	Zip the manual page.
	gzip -9v $(man1dir)/grep-dctrl.1
	set -e ; for dest in grep-status grep-available ; do \
	   $(install_symlink) grep-dctrl.1.gz $(man1dir)/$$dest.1.gz ; \
	 done
#	Install the supporting documentation.
	$(install_nonex) TODO NEWS Compatibility $(docdir)
#	Generate the binary control file.
	dpkg-shlibdeps $(bindir)/grep-dctrl
	dpkg-gencontrol -isp
#	Install the control files
	$(install_nonex) debian/conffiles $(rootdir)/DEBIAN
	$(install_script) debian/prerm debian/postinst $(rootdir)/DEBIAN
#	Fix permissions.
	chown -R root.root $(rootdir)
	chmod -R g-ws $(rootdir)
#	Genearate the deb.
	dpkg --build $(rootdir) ..
	touch binary-arch

define checkdir
	test -f grep-dctrl.c -a -f debian/rules
endef

clean-binary:
	$(RM) debian/binary*.stamp
	$(RM) *~
	$(RM) -r debian/tmp debian/*~ debian/files debian/substvars

clean: clean-build clean-binary

## grep-dctrl 1.9

=== debian/changelog ===
grep-dctrl (1.9) unstable; urgency=low

  * intl/Makefile.in: We don't have a ../config.h.  Closes: #106001

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Mon, 30 Jul 2001 20:09:18 +0300

grep-dctrl (1.8) unstable; urgency=low

  * Fix manpage, closes: #102021

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Thu, 19 Jul 2001 19:40:55 +0300

grep-dctrl (1.7) unstable; urgency=low

  * Added copyright blurb to some source files that missed it.
  * grep-dctrl.c, matcher.[ch]: Implement multiple -F options,
    allows search in several fields at once.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sat, 20 May 2000 18:32:00 +0300

grep-dctrl (1.6) unstable; urgency=low

  * Disable the -c switch to allow its meaning to be changed
    in woody+1.
  * grep-dctrl.1.cp: Added COMPATIBILITY section, based on
    the file Compatibility.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Wed, 10 May 2000 15:29:02 +0300

grep-dctrl (1.5) unstable; urgency=low

  * Incorporate bugfix release 1.3a into the development branch.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sun,  5 Mar 2000 14:23:07 +0200

grep-dctrl (1.4) unstable; urgency=low

  * debian/control [Standards-Version]: 3.1.1
     + debian/control [Build-Depends]: Added
  * debian/control [Description]: Improved.
  * debian/check-sourcedeps: Removed.
  * debian/rules [debian/build-depends.stamp]: Removed.
  * buffer.c, buffer.h: Make buffer_clear() an inline function.
  * grep-dctrl.c (main), matcher.h (struct matcher_t),
    matcher.c (grep_control): Implement the --count option
    suggested by Dirk Eddelbuettel.
  * configure.in, msg.h: Added a --enable-debug-level switch
  * matcher.c (slurp_paragraph): Rewrote for speed.
  * Versions 1.3 and 1.4 together closes: #57144.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sun,  6 Feb 2000 21:42:30 +0200

=== debian/control ===
Source: grep-dctrl
Section: utils
Priority: optional
Maintainer: Antti-Juhani Kaijanaho <ajk@debian.org>
Build-Depends: publib-dev
Standards-Version: 3.1.1

Package: grep-dctrl
Architecture: any
Depends: ${shlibs:Depends}
Description: Grep Debian package information
 The grep-dctrl program can answer such questions as
   * "What is the Debian package foo?"
   * "Which version of the Debian package bar is now current?"
   * "Which Debian packages does John Doe maintain?"
   * "Which Debian packages are somehow related to the Scheme
      programming language?"
 and with some help
   * "Who maintain the essential packages of a Debian system?"
 given a useful input file.
 .
 It is a specialised grep program that is meant for processing any
 file which has the general format of a Debian package control file.
 These include the dpkg available file, the dpkg status file, and the
 Packages files on a distribution medium (such as a Debian CD-ROM or
 an FTP site carrying Debian).

=== debian/rules ===
--- 
+++ 
@@ -22,20 +22,13 @@
 man1dir    = $(mandir)/man1
 
 build: debian/build.stamp
-debian/build.stamp: debian/build-depends.stamp \
-	            debian/build-configure.stamp
+debian/build.stamp: debian/build-configure.stamp
 	$(checkdir)
 	$(MAKE)
 	touch $@
 
 debian/build-configure.stamp:
 	./configure --prefix=/usr --sysconfdir=/etc --mandir=/usr/share
-	touch $@
-
-debian/build-depends.stamp:
-	$(checkdir)
-	chmod u+x debian/check-sourcedeps
-	debian/check-sourcedeps publib-dev
 	touch $@
 
 clean-build:

## grep-dctrl 2.1.4

=== debian/changelog ===
grep-dctrl (2.1.4) unstable; urgency=low

  * predicate.c (verify_atom): Check that the stack contains exactly
    one element (the result) after simulated execution.
    Closes: #241766 (segfault) [Reported by Joey Hess]

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sat, 19 Jun 2004 16:49:24 +0300

grep-dctrl (2.1.3) unstable; urgency=low

  * rc.c (find_ifile_by_exename): Fix EOF handling.
  * grep-dctrl.c (main): If no default file is found, use "-".
  * strutil.c (chomp): New function.
  * These fix a bug that is fuctionally equivalent to 
    bug#235785 (segfaults when using an unknown exe name or an empty config file)
    but is caused by legacy code not present in experimental, and thus this does
    not close it.
  * grep-dctrl.c (finish_atom): Run predicate_finish_atom even if there
    are no search fields.
    Closes: #234657 ("-e" causes matches to fail)

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Wed,  3 Mar 2004 21:21:56 +0200

grep-dctrl (2.1.2) unstable; urgency=low

  * debian/control (Build-Depends): Add version constraint >= 0.11-0 for
    gettext, due to the use of --copyright-holder, with thanks to Michael
    Schultheiss.
    Closes: #230399 (Needs to Build-Depend on versioned gettext)
  * Backport from experimental:
    - debian/control (Suggests): Add dselect
    - debian/control [Description]: Mention the specializations.
  * po/fi.po: Updated.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Wed, 11 Feb 2004 17:40:13 +0200

grep-dctrl (2.1.1) unstable; urgency=low

  * New German translation by Gerfried Fuchs.
  * grep-dctrl.c: Fix help message inconsistent punctuation and other
    minor message errors
    Closes: #229821 (some minor nitpicks with the po files)
  * Makefile (clean): Remove also *.pot
  * predicate.[ch], grep-dctrl.c: Check for malformed predicates.
    This is a kluge, but gets rid of certain assertion failures.
  * Update Catalan translation by Jordi Mallach.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Tue, 10 Feb 2004 20:41:32 +0200

grep-dctrl (2.1.0) unstable; urgency=low

  * Creating a 2.1 maintenance branch - patchlevel added to version number.
  * grep-dctrl.c (main): Use C99 %zi and not %i to print out size_t
    (size mismatch on 64-bit archs).
    Closes: #226569 (printf format problem in grep-dctrl.c)
  * grep-dctrl.c (struct arguments, enter_atom, parse_opt),
    grep-dctrl.1.cp (DIAGNOSTICS): Treat ')' on command line as a "soft"
    '--'; ie. if ')' is followed by a connective, continue predicate,
    otherwise finish it.
    Closes: #226477 (Misparses a file name following a closing paren as a
    pattern)
  * Catalan translation updated by Jordi Mallach.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Tue, 13 Jan 2004 20:14:43 +0200

grep-dctrl (2.0) unstable; urgency=low

  * The Polish Release.
  * Internationalized again,  thanks to Jordi Mallach for help
  * Now includes Catalan messages, courtesy of Jordi Mallach
  * Also includes Finnish messages (my own translation, with thanks to
    Tommi Vainikainen)
  * debian/NEWS: Moved old 1.10x-entries to debian/NEWS.superseded
  * debian/NEWS: Document everything since 1.9
  * debian/rules: ./NEWS is no longer installed, debian/NEWS is better
  * grep-dctrl.c (finish_atom): Zero args->num_search_fields.  This fixes
    a particularly nasty unreported bug, where the right-hand side of an
    --and was essentially ignored.
  * The above changes, along with the changes in 1.103 and 1.104,
    closes: #208646 (Unsuitable for testing)
  * debian/control [Build-Depends]: Add gettext
  * TODO: Updated.
  * grep-dctrl.1.cp: Updated messages in DIAGNOSTICS.
  * grep-dctrl.1.cp: Mention ara(1) in SEE ALSO.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Wed,  7 Jan 2004 03:09:44 +0200

grep-dctrl (1.104) unstable; urgency=low

  * grep-dctrl.c (parse_option [case 's']): free carg after use
  * grep-dctrl.c (parse_option): Replace remaining FIXME-tagged asserts
    with proper error checking
  * Bring back support for multiple -F options in one atom and multiple
    field names in one -F option:
    - grep-dctrl.c (struct arguments, leave, prim_enter): Allow an
      instruction sequence in the parser stack.
    - grep-dctrl.c (clone_atom): New function.
    - grep-dctrl.c (finish_atom, parse_option [case 'F']):
      Handle multiple field names.
    - grep-dctrl.1.cp: Remove note of the regression.
    - debian/NEWS: Note this change.
    This gets rid of one of the documented regressions.
  * grep-dctrl.c (options): Make --banner existence contingent on the
    BANNER #define.
  * grep-dctrl.c, predicate.h, predicate.c, grep-dctrl.1.cp: Add a new
    instruction, I_TRUE, and use it to implement --true.
  * grep-dctrl.c (to_stdout, parse_option [case 'C']): Implement -C.
    Closes: #207995 (grep-dctrl: -C: (PROGRAM ERROR) Option should have
    been recognized!?)
  * debian/control (Standards-Version): 3.6.1, no changes required.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sat,  3 Jan 2004 20:54:36 +0200

grep-dctrl (1.103) unstable; urgency=low

  * grep_dctrl.c (banner, main, parse_option): Disable the banner.
  * predicate.c (predicate_finish_atom): Don't bail out if the field name
    is missing; instead, just don't add the missing field name to the
    trie.  Thanks to Jeff King for diagnosis and patch.
    Closes: #205998 (regex/eregex support produces no results)
  * grep-dctrl.c (main): Track whether any matches were found and choose
    exit status based on that.
    Closes: #216549 (Return 0 for success, 1 for failure, like grep does)
  * grep-dctrl.1.cp: Add grep-available and grep-status to NAME section
    and mention them in the SYNOPSIS.
    Closes: #199762 (mention grep-available in synopsys)
  * grep-dctrl.1.cp: Add dpkg available and status files to FILES section.
    Closes: #204781 (Add available and status file to FILES section on the
    man page)
  * Use the grep return value 2 for errors:
    - msg.h (fail, errors_reported, record_error): New function.


## grep-dctrl 2.1.8

=== debian/changelog ===
grep-dctrl (2.1.8) unstable; urgency=low

  * po/pt_BR.po: New translation by Mauricio Vieira.
  * grep-dctrl.c (enter_atom, clone_atom): Add sizeof to mallocs.
    Closes: #285439 (Fail with combined predicates)
                    [Reported by Pierre THIERRY]
  * Fix -Fxxx,yyy handling:
    - grep-dctrl.c (clone_atom): The *old* atom must receive the 
                                 compound predicate code.
    - grep-dctrl.c (parse_prim): Actually *use* the atom's code
                                 instead of just I_PUSH.
    Closes: #285738 (grep-dctrl doesn't search all the -F fields somehow)
                    [Reported by Gerfried Fuchs]
  * msg.h (msg_get_progname): Fix progname type inconsistency.
    Closes: #286912 (FTBFS (amd64/gcc-4.0): conflicting types for 'progname')
                    [Reported by Andreas Jochens]
  * grep-dctrl: Add a .args_doc field to argp, fixing the usage summary.
    Closes: #287746 (usage message incorrect) [Reported by Branden Robinson]

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Fri, 31 Dec 2004 05:28:00 +0200

grep-dctrl (2.1.7) unstable; urgency=low

  * Apply patch by Andreas Metzler.  Closes: #265858 (Unescaped dashes in
    manpage break searching or cut-and-paste with UTF-8 locale)

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Mon, 16 Aug 2004 19:52:03 +0300 

grep-dctrl (2.1.6) unstable; urgency=low

  * Translation update release.
  * grep-dctrl.c (main): Shorten the new #236196 warning
    (the old was problematic for translators).
  * msg.c: Update author snail-mail address.
  * po/fi.po: Updated.
  * po/de.po: Updated by Gerfried Fuchs.
  * po/ca.po: Updated by Jordi Mallach.
  * po/fr.po: Updated by Nicolas Bertolissio.
  * langs.mk, po/it.po: New translation by Danilo Piazzalunga.
    Closes: #258389 (Italian translation for r_2_1_maint branch)
  * grep-dctrl.1.cp: Change license to GPL.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Fri,  9 Jul 2004 19:30:59 +0300

grep-dctrl (2.1.5) unstable; urgency=low

  * msg.[ch]: Rearranging.
  * msg.h (msg_get_progname): New function.
  * grep-dctrl.c: Rewrite the parser so that argp only
    produces a list of tokens for a new recursive-descent
    predicate parser.
    Closes: #227543 (Predicate parser is fragile) [Reported by AJK]
  * French translation by Nicolas Bertolissio, proofread by
    Michel Grentzinger, Claude Thomassin and Denis Barbier
  * po/fi.po: Updated.
  * getaline.c (getaline): Ensure that there is a null terminator in an
    empty return value.
  * grep-dctrl.c (main): Warn about the use of standard input when the
    command name was not found.
    Closes: #236196 (please tell the user when falling back to reading stdin)
    [Reported by Danilo Piazzalunga]

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sun,  4 Jul 2004 15:12:04 +0300

## grep-dctrl 2.1.11

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 CC = gcc -std=gnu99 
 CFLAGS = -O2 -g -Wall -DENABLE_L_DEBUG -D_GNU_SOURCE -DSYSCONF=\"$(sysconfdir)\" \
-         -DHAVE_GETTEXT -DPACKAGE=\"grep-dctrl\" -DLOCALEDIR=\"$(localedir)\"
+         -DHAVE_GETTEXT -DPACKAGE=\"grep-dctrl\" -DLOCALEDIR=\"$(localedir)\" 
 
 CFLAGS += -DVERSION=\"$(shell dpkg-parsechangelog | grep '^Version' | cut -b10-)\"
 CFLAGS += -DMAINTAINER='"$(shell grep ^Maintainer: debian/control | cut -b13-)"'

=== debian/changelog ===
grep-dctrl (2.1.11) unstable; urgency=medium

  * po/fi.po: Fix encoding mistakes.
    Closes: #310988 (bad char in Finnish translation)
    [Reported by Lars Wirzenius <liw@iki.fi>]

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Fri, 27 May 2005 19:22:50 +0300

grep-dctrl (2.1.10) unstable; urgency=medium

  * grep-dctrl.1.cp: Reinsert COMPATIBILITY section, which seems to have
    been removed accidentally just prior to 2.0.  Thanks to Ian Lynagh for
    spotting this.
  
 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Fri,  8 Apr 2005 16:42:15 +0300

grep-dctrl (2.1.9) unstable; urgency=low

  * grep-dctrl.c: Allow atoms to share code, and use that
    to build the common code when atoms are cloned.
    Closes: #299597 (different search results based on order of field names)
                     [Reported by Michael Koch]
    (The older fix was only partial in that if more than two were
     cloned, only the first two clones were honored.)

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sat, 26 Mar 2005 01:09:01 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,13 @@
 Section: utils
 Priority: optional
 Maintainer: Antti-Juhani Kaijanaho <ajk@debian.org>
-Build-Depends: publib-dev
-Standards-Version: 3.1.1
+Standards-Version: 3.6.1
+Build-Depends: gettext (>= 0.11-0)
 
 Package: grep-dctrl
 Architecture: any
 Depends: ${shlibs:Depends}
+Suggests: dselect
 Description: Grep Debian package information
  The grep-dctrl program can answer such questions as
    * "What is the Debian package foo?"
@@ -24,3 +25,9 @@
  These include the dpkg available file, the dpkg status file, and the
  Packages files on a distribution medium (such as a Debian CD-ROM or
  an FTP site carrying Debian).
+ .
+ This package includes the specializations grep-status and
+ grep-available, which take their input by default from the dpkg
+ status file and the dpkg available file (updated by dselect update),
+ respectively.  The grep-available specialization is useful mainly to
+ users of dselect.

=== debian/rules ===
#!/usr/bin/make -f
# Written by Antti-Juhani Kaijanaho <ajk@debian.org>.  
# You may treat this file as if it were in the public domain.

librules_interface = 2
librules_native_pkg=yes
include debian/librules.mk

include langs.mk

debian/stamp/build: #debian/stamp/build-configure
	$(MAKE)
	touch $@

#debian/stamp/build-configure:
#	./configure --prefix=/usr --sysconfdir=/etc --mandir=/usr/share
#	touch $@

clean-build:
	-$(MAKE) clean

debian/stamp/binary/arch: debian/stamp/binary/grep-dctrl

debian/stamp/binary/grep-dctrl: package=grep-dctrl
debian/stamp/binary/grep-dctrl: debian/stamp/build
	$(prebinary)
#	Install by the master makefile
#	$(MAKE) prefix=$(rootdir)/usr sysconfdir=$(rootdir)/etc \
#	  mandir=$(mandir) install
#	Install configuration file
	$(install_dir) $(etcdir)
	$(install_nonex) grep-dctrl.rc $(etcdir)
#	Install the binary.
	$(install_dir) $(bindir)
	$(install_exec) grep-dctrl $(bindir)
	set -e ; for dest in grep-status grep-available ; do \
	   $(install_symlink) grep-dctrl $(bindir)/$$dest ; \
	 done
#	Zip the manual page.
	$(install_dir) $(man1dir)
	$(install_nonex) grep-dctrl.1 $(man1dir)/
	$(gzip) $(man1dir)/grep-dctrl.1
	set -e ; for dest in grep-status grep-available ; do \
	   $(install_symlink) grep-dctrl.1.gz $(man1dir)/$$dest.1.gz ; \
	 done
#	Install the supporting documentation.
	$(install_nonex) TODO Compatibility $(docdir)
#	Install message catalogues
	set -e ; for lang in $(langs) ; do \
		$(install_dir) $(rootdir)/usr/share/locale/$$lang/LC_MESSAGES ; \
		$(install_nonex) po/$$lang.mo \
		  $(rootdir)/usr/share/locale/$$lang/LC_MESSAGES/$(package).mo ; \
	done
#	Install config file information
	$(install_nonex) debian/conffiles $(rootdir)/DEBIAN
#	Get the shared library deps
	dpkg-shlibdeps $(bindir)/grep-dctrl
	$(postbinary)
	touch $@

clean-binary:
	$(RM) *~

## grep-dctrl 2.6.6ubuntu1

=== Makefile ===
--- 
+++ 
@@ -1,27 +1,28 @@
 
 sysconfdir = /etc
 localedir = /usr/share/locale
+version := $(shell dpkg-parsechangelog | grep '^Version' | cut -b10-)
 
 CC = gcc -std=gnu99 
 CFLAGS = -O2 -g -Wall -DENABLE_L_DEBUG -D_GNU_SOURCE -DSYSCONF=\"$(sysconfdir)\" \
          -DHAVE_GETTEXT -DPACKAGE=\"grep-dctrl\" -DLOCALEDIR=\"$(localedir)\" 
 
-CFLAGS += -DVERSION=\"$(shell dpkg-parsechangelog | grep '^Version' | cut -b10-)\"
+CFLAGS += -DVERSION=\"$(version)\"
 CFLAGS += -DMAINTAINER='"$(shell grep ^Maintainer: debian/control | cut -b13-)"'
 
 #CFLAGS += -pg
 #LDFLAGS += -pg
 
-#LDLIBS = -lpub
+#LDLIBS = -lgmp
 
-obj = grep-dctrl.o msg.o predicate.o util.o fsaf.o paragraph.o \
+obj = grep-dctrl.o misc.o msg.o predicate.o util.o fsaf.o paragraph.o \
       fieldtrie.o rc.o strutil.o getaline.o fnutil.o
 src = $(obj:.o=.c)
 
 # List of translated languages is given in langs.mk
 include langs.mk
 
-all : grep-dctrl grep-dctrl.1 mo
+all : grep-dctrl grep-dctrl.1 sync-available mo
 
 pot : po/grep-dctrl.pot
 
@@ -38,6 +39,10 @@
 
 %.1 : %.1.cp
 	sed 's*SYSCONF*$(sysconf)*' $< > $@
+
+sync-available : sync-available.cp
+	sed 's*VERSION*$(version)*' $< > $@
+	chmod 755 $@
 
 xgettext_opts=--copyright-holder="Antti-Juhani Kaijanaho" \
 	      --msgid-bugs-address="ajk@debian.org" -kN_ -k_
@@ -56,6 +61,7 @@
 
 clean :
 	$(RM) core grep-dctrl grep-dctrl.1 *.o po/*.mo po/*.pot TAGS
+	$(RM) sync-available
 
 tags :
 	etags *.[hc]

=== debian/changelog ===
grep-dctrl (2.6.6ubuntu1) breezy; urgency=low

  * Fix FTBFS: apply patch from
    http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=314601.

 -- Fabio M. Di Nitto <fabbione@ubuntu.com>  Tue, 21 Jun 2005 15:47:46 +0200

grep-dctrl (2.6.6) unstable; urgency=low

  * Go to unstable again.
  * Merge 2.1.10 and 2.1.11 (no po/ merge).
  * po/fi.po: Sync translation with 2.1.11.
  * Change numeric comparison to version number comparison.
    Noteworthy individual changes:
      + debian/control: Drop libgmp3-dev build-dependency.
      + Makefile: No longer link with libgmp.
      + grep-dctrl.1.cp: Document, remove earlier warnings.
      + grep-dctrl.c: Document, remove earlier warnings (etc.)
      + predicate.c: Replace numeric comparison with version
        comparison.  Copy the actual comparison code from dpkg.
      + paragraph.[ch]: No longer do a numeric parse.
      + debian/copyright: Document dpkg copyright.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Wed,  8 Jun 2005 19:25:10 +0300

grep-dctrl (2.6.5) experimental; urgency=low

  * po/pt_BR.po: New translation by Mauricio Vieira.
  * Merged 2.1.7, 2.1.8 and 2.1.9 (no po/ merge).

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sat, 26 Mar 2005 06:04:19 +0200

grep-dctrl (2.6.4) experimental; urgency=low

  * debian/control (Build-Depends): gcc (>= 3.0)
  * debian/README: New file.
  * debian/rules: Install debian/README as README.Debian.
  * grep-dctrl.1.cp: Warn about coming semantics change for
    numeric comparisons.  
  * grep-dctrl.c: Add warning about coming semantics change for
    numeric comparisons. 

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sat, 17 Jul 2004 04:44:40 +0300

grep-dctrl (2.6.3) experimental; urgency=low

  * sync-available.cp, Makefile: Fix the goofup which made sync-available
    not be generated from sync-available.cp.
  * grep-dctrl.c, misc.[ch], Makefile: Backport from CVS HEAD the
    following change:
      * misc.c (to_stdout), misc.h, grep-dctrl.c (to_stdout):
        Move to_stdout to a library object.
      * misc.c (to_stdout): Use a pager if stdout is a tty.
  * debian/NEWS: Uploads >= 2.2 were to experimental.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Mon, 12 Jul 2004 17:50:14 +0300

grep-dctrl (2.6.2) experimental; urgency=low

  * sync-available: -ge 1, not -gt 1, when comparing the number of
    arguments.  Thanks to Pasi Savolainen.
  * Belated thanks to Juhapekka Tolvanen for inspiring the sync-available
    script.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Mon, 12 Jul 2004 04:24:49 +0300

grep-dctrl (2.6.1) experimental; urgency=low

  * sync-available.cp, Makefile, debian/rules: New program.
  * sync-available.8, debian/rules: New manual page.
  * debian/NEWS: Note new program sync-available.
  * debian/control (Suggests): No longer suggest dselect.
  * debian/control (Desrciption): Rephrase grep-available and note
    sync-available.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sun, 11 Jul 2004 20:12:13 +0300

grep-dctrl (2.6.0) experimental; urgency=low

  * Creating a 2.6 maintenance branch - patchlevel added to version number.
  * po/fi.po: Updated.
  * po/it.po: New translation by Danilo Piazzalunga.
    Closes: #258388 (Italian translation for HEAD)
  * Merge 2.1.6 (no po/*.po merge).

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sat, 10 Jul 2004 00:32:23 +0300

grep-dctrl (2.5) experimental; urgency=low

  * Merge 2.1.4.
  * Merge 2.1.5.
    - lose its fix for #236196
    - no po/*.po merge
  * rc.c (parse, find_ifile_by_exename): Apply Danilo Piazzalunga's patch
    to fix #236196.
  * Makefile, debian/control (Build-Depends): Link against libgmp3.
  * paragraph.[ch], predicate.[ch]: Use libgmp to implement
    unlimited-precision integers for numeric comparisons.
  * po/de.po: Updated by Gerfried Fuchs.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Mon,  5 Jul 2004 14:43:45 +0300

grep-dctrl (2.4) experimental; urgency=low

  * Update Catalan translation (Jordi Mallach).
  * Merge 2.1.1.
  * Merge 2.1.2.
  * debian/control (Description): Minor edit.
  * Merge 2.1.3.
  * rc.c (parse): Check for null s before, not after it is first
    dereferenced.  Thanks to Danilo Piazzalunga.
    Closes: #235785 (segfaults when using an unknown exe name or an empty
    config file)
  * French translation by Nicolas Bertolissio, proofread by
    Michel Grentzinger, Claude Thomassin and Denis Barbier

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Thu,  4 Mar 2004 20:03:33 +0200

grep-dctrl (2.3) experimental; urgency=low

  * Add numeric comparison capability
    Closes: #157042 (could allow numeric comparison on fields)

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Sun, 18 Jan 2004 00:46:59 +0200

grep-dctrl (2.2) experimental; urgency=low

  * This version starts adding features and thus belongs in experimental.
  * rc.h, rc.c, grep-dctrl.c, grep-dctrl.1.cp:
    Add @exec syntax to rc files, and support reading stdout of given commands
  * debian/rules, grep-dctrl.rc: Add grep-aptavail
    Closes: #207440 (grep-available for apt?)
  * debian/control [Suggests]: Add dselect and apt
  * debian/control [Description]: Mention the specializations.

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Fri, 16 Jan 2004 03:08:58 +0200

=== debian/control ===
Source: grep-dctrl
Section: utils
Priority: optional
Maintainer: Antti-Juhani Kaijanaho <ajk@debian.org>
Standards-Version: 3.6.1
Build-Depends: gettext (>= 0.11-0), gcc (>= 3.0)

Package: grep-dctrl
Architecture: any
Depends: ${shlibs:Depends}
Suggests: apt
Description: Grep Debian package information
 The grep-dctrl program can answer such questions as
   * "What is the Debian package foo?"
   * "Which version of the Debian package bar is now current?"
   * "Which Debian packages does John Doe maintain?"
   * "Which Debian packages are somehow related to the Scheme
      programming language?"
 and with some help
   * "Who maintain the essential packages of a Debian system?"
 given a useful input file. 
 .
 It is a specialised grep program that is meant for processing any
 file which has the general format of a Debian package control file.
 These include the dpkg available file, the dpkg status file, and the
 Packages files on a distribution medium (such as a Debian CD-ROM or
 an FTP site carrying Debian).
 .
 This package includes the specializations grep-status, grep-available
 and grep-aptavail, which take their input by default from the dpkg
 status file, the dpkg available file (updated by dselect update, but
 see below) and the apt available database (updated by apt-get
 update), respectively.  The grep-available specialization is useful
 mainly to users of dselect or apt, while grep-aptavail only works if
 apt is installed.
 .
 A script, sync-available, which syncs the dpkg available file to the
 apt available database without requiring dselect, is included.

=== debian/rules ===
--- 
+++ 
@@ -21,6 +21,8 @@
 
 debian/stamp/binary/arch: debian/stamp/binary/grep-dctrl
 
+aliases = grep-status grep-available grep-aptavail
+
 debian/stamp/binary/grep-dctrl: package=grep-dctrl
 debian/stamp/binary/grep-dctrl: debian/stamp/build
 	$(prebinary)
@@ -30,21 +32,27 @@
 #	Install configuration file
 	$(install_dir) $(etcdir)
 	$(install_nonex) grep-dctrl.rc $(etcdir)
-#	Install the binary.
+#	Install the binaries.
+	$(install_dir) $(sbindir)
+	$(install_script) sync-available $(sbindir)
 	$(install_dir) $(bindir)
 	$(install_exec) grep-dctrl $(bindir)
-	set -e ; for dest in grep-status grep-available ; do \
+	set -e ; for dest in $(aliases) ; do \
 	   $(install_symlink) grep-dctrl $(bindir)/$$dest ; \
 	 done
-#	Zip the manual page.
+#	Install and zip the manual pages.
+	$(install_dir) $(man8dir)
+	$(install_nonex) sync-available.8 $(man8dir)/
+	$(gzip) $(man8dir)/sync-available.8
 	$(install_dir) $(man1dir)
 	$(install_nonex) grep-dctrl.1 $(man1dir)/
 	$(gzip) $(man1dir)/grep-dctrl.1
-	set -e ; for dest in grep-status grep-available ; do \
+	set -e ; for dest in $(aliases) ; do \
 	   $(install_symlink) grep-dctrl.1.gz $(man1dir)/$$dest.1.gz ; \
 	 done
 #	Install the supporting documentation.
 	$(install_nonex) TODO Compatibility $(docdir)
+	$(install_nonex) debian/README $(docdir)/README.Debian
 #	Install message catalogues
 	set -e ; for lang in $(langs) ; do \
 		$(install_dir) $(rootdir)/usr/share/locale/$$lang/LC_MESSAGES ; \

## grep-dctrl 2.6.7

=== debian/changelog ===
grep-dctrl (2.6.7) unstable; urgency=low

  * fr.po: Update by Nicolas Bertolissio.
    Closes: #314893 (French translation update of gettext debconf template)
    (Nothing to do with debconf regardless of the bug title)
  * msg.h: Fix progname type.
    Closes: #314601 (FTBFS (amd64/gcc-4.0): conflicting types for 'progname')
    [Reported by Andreas Jochens]
  * grep-dctrl.1.cp: Fix "preceding" typo.
    Closes: #311032 *'man grep-dctrl' typo: "predecing")
    [Reported by A Costa]
  * sync-available.8: Miscellaneous fixes.
    Closes: #312630 (sync-available(8) thinks it is update-avail(8))
    [Reported by Antti-Juhani Kaijanaho]
    Closes: #312766 ('man sync-available' typo: "aquisition")
    [Reported by A Costa]

 -- Antti-Juhani Kaijanaho <ajk@debian.org>  Mon, 11 Jul 2005 18:26:46 +0300
